<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: field/hext_cu.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_00a13ab5e3afe633796d5c180ae90994.html">field</a>
  </div>
</div>
<div class="contents">
<h1>hext_cu.c</h1><a href="hext__cu_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: hext_cu.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">static</span> <span class="keywordtype">int</span>       doinit=1;
<a name="l00030"></a>00030 <span class="keyword">static</span> <span class="keywordtype">int</span>       fieldon=0;
<a name="l00031"></a>00031 <span class="keyword">static</span> Vec       VHthis;
<a name="l00032"></a>00032 <span class="keyword">static</span> PetscReal hextamp=0.5; <span class="comment">/* Field strength in Tesla */</span>
<a name="l00033"></a>00033 
<a name="l00034"></a><a class="code" href="hext__cu_8c.html#ad490e336bf2582884e7e3191bd37891a">00034</a> <span class="keywordtype">int</span> <a class="code" href="hext__cu_8c.html#ad490e336bf2582884e7e3191bd37891a">Hext_cu_Init</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   PetscTruth     flg;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-hext_cu&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;fieldon,&amp;flg);CHKERRQ(ierr);
<a name="l00041"></a>00041   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00042"></a>00042     fieldon=0;
<a name="l00043"></a>00043     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00044"></a>00044       <span class="stringliteral">&quot;Option -hext_cu not found, using default value: %i (field off)\n&quot;</span>,
<a name="l00045"></a>00045       fieldon
<a name="l00046"></a>00046     );
<a name="l00047"></a>00047   }
<a name="l00048"></a>00048   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00049"></a>00049     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Hext_cu off\n&quot;</span>);
<a name="l00050"></a>00050     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00051"></a>00051   }
<a name="l00052"></a>00052   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Hext_cu on\n&quot;</span>);
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;VHthis);CHKERRQ(ierr);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="comment">/* this example sets the external field in a certain area to a</span>
<a name="l00057"></a>00057 <span class="comment">     non-zero value and everywhere else to zero</span>
<a name="l00058"></a>00058 <span class="comment">  */</span>
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <span class="comment">/* make the vector of the external field accessible */</span>
<a name="l00061"></a>00061   PetscReal *ta_Hext;
<a name="l00062"></a>00062   ierr = VecGetArray(VHthis,&amp;ta_Hext);CHKERRQ(ierr);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="comment">/* loop over all (local) nodes */</span>
<a name="l00065"></a>00065   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; j++) {
<a name="l00066"></a>00066     <span class="comment">/* select nodes within a rectangular area */</span>
<a name="l00067"></a>00067     <span class="keywordflow">if</span> (
<a name="l00068"></a>00068       gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[j]+0]&gt;=65.0 &amp;&amp;
<a name="l00069"></a>00069       gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[j]+0]&lt;=250.0 &amp;&amp;
<a name="l00070"></a>00070       gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[j]+1]&gt;=192.0 &amp;&amp;
<a name="l00071"></a>00071       gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[j]+1]&lt;=310.0
<a name="l00072"></a>00072     ) {
<a name="l00073"></a>00073       <span class="comment">/* set the direction of the field (unit vector!) */</span>
<a name="l00074"></a>00074 
<a name="l00075"></a>00075       PetscReal hextxyz[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>]={1.0,0.0,0.0};
<a name="l00076"></a>00076       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>; i++) {
<a name="l00077"></a>00077         ta_Hext[ND*j+i]=hextxyz[i];
<a name="l00078"></a>00078       }
<a name="l00079"></a>00079     }
<a name="l00080"></a>00080     <span class="keywordflow">else</span> {
<a name="l00081"></a>00081       <span class="comment">/* set the field to zero outside the rectangular area */</span>
<a name="l00082"></a>00082       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>; i++) {
<a name="l00083"></a>00083         ta_Hext[ND*j+i]=0.0;
<a name="l00084"></a>00084       }
<a name="l00085"></a>00085     }
<a name="l00086"></a>00086   }
<a name="l00087"></a>00087   ierr = VecRestoreArray(VHthis,&amp;ta_Hext);CHKERRQ(ierr);
<a name="l00088"></a>00088   
<a name="l00089"></a>00089   <span class="comment">/* scale the vector to set the field strength */</span>
<a name="l00090"></a>00090   ierr = VecScale(gdata-&gt;<a class="code" href="structGridData.html#a9fdfeb31eb70dd07c65f5717feddcdbf">VHext</a>,hextamp);CHKERRQ(ierr);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="hext__cu_8c.html#a2866a2d9dd35b17789e06b1b79ab72cc">00096</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#a2866a2d9dd35b17789e06b1b79ab72cc">Hext_cu</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec VHextsum,PetscReal *hext)
<a name="l00097"></a>00097 {
<a name="l00098"></a>00098   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="comment">/* to be implemented by the user */</span>
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="keywordflow">if</span> (doinit) {
<a name="l00103"></a>00103     ierr = <a class="code" href="hext__cu_8c.html#ad490e336bf2582884e7e3191bd37891a">Hext_cu_Init</a>(gdata);CHKERRQ(ierr);
<a name="l00104"></a>00104     doinit=0;
<a name="l00105"></a>00105   }
<a name="l00106"></a>00106   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00107"></a>00107     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00108"></a>00108   }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   ierr = VecAXPY(VHextsum,1.0,VHthis);CHKERRQ(ierr);
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   *hext=hextamp;
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

